//importing the required methods
import { select, json, geoPath, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

//selecting the svg in the html page
const svg = select('svg');

//saving the geoNaturalEarth functionality in a variable
const projection = geoNaturalEarth1();
//Generating the geopath for the geoNaturalEarth
const pathGenerator = geoPath().projection(projection);

//append the patha and sphere, pathgenerator to the selected svg
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

//access the topojson data using the gist url and append it to the path of the svg with a class name country
json('https://gist.githubusercontent.com/gallachaitanya/2335c57153161198e0dd6d923fe00ed7/raw/ebc571eec0af7662c568db94aef5794e2c352709/worldMap.json')
  .then(data => {
    const countries = feature(data, data.objects.countries);
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });